var Details = function()
{
	var details = {};
	var debug = 0;
	
	// Page initialization
	details.initPage = function()
	{
		Buttons.addClickHandler('close', App.closeWindow);
		Buttons.addClickHandler('btnSave', details.saveDetails);

/*		
		Events.addEventHandler('qiacubePosition', 'keypress', Events.integerOnly);
*/
/*
		Events.addEventHandler('lysateOriginalQuantity', 'keypress', Events.numberOnly);
		Events.addEventHandler('lysateUsedQuantity', 'keypress', Events.numberOnly);
*/
/*
		Events.addEventHandler('specimenOriginalQuantity', 'keypress', Events.numberOnly);
		Events.addEventHandler('specimenUsedQuantity', 'keypress', Events.numberOnly);
*/
		Events.addEventHandler('dnaVolume', 'keypress', Events.numberOnly);
		Events.addEventHandler('rnaVolume', 'keypress', Events.numberOnly);
/*
		Events.addEventHandler('ftVolume', 'keypress', Events.numberOnly);
*/
		
		var index = Data.int('page-data', 'index');
		var frm = document.forms['details'];
		var pfrm = window.opener.document.forms['meludi'];
/*
		var lysate = pfrm.lysates[index].lysate;
*/
/*
		var specimen = pfrm.specimens[index].specimen;
*/
		//var specimen = pfrm.extractSourceItems[index].specimen;
		var selItemsList = getSelectedItemsList();
		var item = selItemsList[index];
		var specimen = item;

/*
		frm.qiacubePosition.value = lysate.qiacubePosition;
		frm.lysateOriginalQuantity.value = lysate.originalQuantity;
		frm.lysateUsedQuantity.value = lysate.processedQuantity;
*/
		frm.qiacubePosition.value = specimen.qiacubePosition;
/*
		frm.specimenOriginalQuantity.value = specimen.originalQuantity;
		frm.specimenUsedQuantity.value = specimen.processedQuantity;
*/
		frm.dnaVolume.value = specimen.dna.volume;
		frm.rnaVolume.value = specimen.rna.volume;
/*
		frm.ftVolume.value = lysate.ft.volume;
*/

/*
		frm.lysateComment.value = lysate.comment || '';
		frm.dnaComment.value = lysate.dna.comment || '';
		frm.rnaComment.value = lysate.rna.comment || '';
		frm.ftComment.value = lysate.ft.comment || '';
*/
		frm.specimenComment.value = specimen.comment || '';
		frm.dnaComment.value = specimen.dna.comment || '';
		frm.rnaComment.value = specimen.rna.comment || '';

		var reagents = window.opener.ExtractionReg.REAGENTS;
		for (var i = 0; i < reagents.length; i++)
		{
			var rg = reagents[i];
/*
			frm[rg].value = lysate[rg] || '';
*/
			frm[rg].value = specimen[rg] || '';
			Doc.element(rg+'.default').innerHTML = Strings.encodeTags(pfrm[rg].value);
		}
		
		details.checkForm();
		frm.qiacubePosition.focus();
	}
	
	details.checkForm = function()
	{
		var frm = document.forms['details'];
		
		var index = Data.int('page-data', 'index');
		var selItemsList = getSelectedItemsList();
		var item = selItemsList[index];

		// Qiacube position
		var qiacubePositionStr = frm.qiacubePosition.value;
		if (isSpecimen(item))
		{
			// Check prefix indicating QIAcube instrument
			var qiacubeInstrPrefix = qiacubePositionStr.substring(0,1);
			if (/^[A-Z]$/.test(qiacubeInstrPrefix) == false)
			{
				Forms.showNotification('qiacubePosition', 'QIAcube instrument prefix must be uppercase letter A-Z.');
				return false;
			}
			// Remove prefix indicating QIAcube instrument
			qiacubePositionStr = qiacubePositionStr.substring(1);
			var qiacubePosition = parseInt(qiacubePositionStr, 10);
			if (qiacubePosition < 1 || qiacubePosition > 12)
			{
				Forms.showNotification('qiacubePosition', 'QIAcube position must be between 1 and 12.');
				return false;
			}
		}
		else
		{
			if (qiacubePositionStr)
			{
				Forms.showNotification('qiacubePosition', 'Input RNA and DNA do not have a QIAcube position.');
				return false;
			}
		}

/*		
		// Lysate quantities
		var lysateOriginalQuantity = parseFloat(frm.lysateOriginalQuantity.value);
		if (!(lysateOriginalQuantity > 0))
		{
			Forms.showNotification('lysateOriginalQuantity', 'Invalid value for Lysate total quantity.');
			return false;
		}
		var lysateUsedQuantity = parseFloat(frm.lysateUsedQuantity.value);
		if (!(lysateUsedQuantity > 0))
		{
			Forms.showNotification('lysateUsedQuantity', 'Invalid value for Lysate used quantity.');
			return false;
		}
		if (lysateUsedQuantity > lysateOriginalQuantity)
		{
			Forms.showNotification('lysateUsedQuantity', 'Lysate used quantity is bigger than total quantity.');
			return false;
		}
*/
/*
		// Specimen quantities
		var specimenOriginalQuantity = parseFloat(frm.specimenOriginalQuantity.value);
		if (!(specimenOriginalQuantity > 0))
		{
			Forms.showNotification('specimenOriginalQuantity', 'Invalid value for Specimen total quantity.');
			return false;
		}
		var specimenUsedQuantity = parseFloat(frm.specimenUsedQuantity.value);
		if (!(specimenUsedQuantity > 0))
		{
			Forms.showNotification('specimenUsedQuantity', 'Invalid value for Specimen used quantity.');
			return false;
		}
		if (specimenUsedQuantity > specimenOriginalQuantity)
		{
			Forms.showNotification('specimenUsedQuantity', 'Specimen used quantity is bigger than total quantity.');
			return false;
		}
*/

		// DNA
		var dnaVolume = parseFloat(frm.dnaVolume.value);
		if (!(dnaVolume > 0))
		{
			Forms.showNotification('dnaVolume', 'Invalid value for DNA volume.');
			return false;
		}

		// RNA
		var rnaVolume = parseFloat(frm.rnaVolume.value);
		if (!(rnaVolume > 0))
		{
			Forms.showNotification('rnaVolume', 'Invalid value for RNA volume.');
			showError('Invalid value for RNA volume.');
			return false;
		}

/*	
		// FT
		var ftVolume = parseFloat(frm.ftVolume.value);
		if (!(ftVolume > 0))
		{
			Forms.showNotification('ftVolume', 'Invalid value for FT volume.');
			return false;
		}
*/

		return true;
	}

	details.saveDetails = function()
	{
		if (!details.checkForm()) return;
		
		var index = Data.int('page-data', 'index');
		var mode = Data.get('page-data', 'mode');
/*
		var lysate = window.opener.document.forms['meludi'].lysates[index].lysate;
*/
/*
		var specimen = window.opener.document.forms['meludi'].specimens[index].specimen;
*/
		//var specimen = window.opener.document.forms['meludi'].extractSourceItems[index].specimen;
		//var specimen = pfrm.extractSourceItems[index].specimen;
		var selItemsList = getSelectedItemsList();
		var item = selItemsList[index];
		var specimen = item;
		var frm = document.forms['details'];

/*
		lysate.qiacubePosition = parseInt(frm.qiacubePosition.value, 10);
		lysate.originalQuantity = parseFloat(frm.lysateOriginalQuantity.value);
		lysate.processedQuantity = parseFloat(frm.lysateUsedQuantity.value);
		lysate.comment = frm.lysateComment.value;

		lysate.dna.volume = parseFloat(frm.dnaVolume.value);
		lysate.dna.comment = frm.dnaComment.value;
		lysate.rna.volume = parseFloat(frm.rnaVolume.value);
		lysate.rna.comment = frm.rnaComment.value;
		lysate.ft.volume = parseFloat(frm.ftVolume.value);
		lysate.ft.comment = frm.ftComment.value;
*/
/*
		specimen.qiacubePosition = parseInt(frm.qiacubePosition.value, 10);
*/
		specimen.qiacubePosition = frm.qiacubePosition.value;
/*
		specimen.originalQuantity = parseFloat(frm.specimenOriginalQuantity.value);
		specimen.processedQuantity = parseFloat(frm.specimenUsedQuantity.value);
*/
		specimen.comment = frm.specimenComment.value;

		specimen.dna.volume = parseFloat(frm.dnaVolume.value);
		specimen.dna.comment = frm.dnaComment.value;
		specimen.rna.volume = parseFloat(frm.rnaVolume.value);
		specimen.rna.comment = frm.rnaComment.value;

		if (mode != null && mode == 'ExtractionReg')
		{
			var reagents = window.opener.ExtractionReg.REAGENTS;
			for (var i = 0; i < reagents.length; i++)
			{
				var rg = reagents[i];
				specimen[rg] = frm[rg].value || null;
			}
		}
/*		
		var reagents = window.opener.ExtractionReg.REAGENTS;
		for (var i = 0; i < reagents.length; i++)
		{
			var rg = reagents[i];
			specimen[rg] = frm[rg].value || null;
		}
*/

		if (mode != null && mode == 'ExtractionReg')
		{
			window.opener.ExtractionReg.updateDetailsTable();
		}
		else
		{
			window.opener.ExtractionPrep.updateDetailsTable();
		}
/*	
		window.opener.ExtractionReg.updateDetailsTable();
*/
		window.close();
	}

	isSpecimen = function(item)
	{
		var isSpecimen = false;
		if (item != null)
		{
			if (!isRna(item) && !isDna(item))
			{
				isSpecimen = true;
			}
		}
		return isSpecimen;
	}

	isRna = function(item)
	{
		var isRna = false;
		if (item != null)
		{
			var name = item.name;
			if (name != null)
			{
				// Check if item name ends with ".r"
				if (name.indexOf('.r') == (name.length - 2))
				{
					isRna = true;
				}
			}
		}
		return isRna;
	}

	isDna = function(item)
	{
		var isDna = false;
		if (item != null)
		{
			var name = item.name;
			if (name != null)
			{
				// Check if item name ends with ".d"
				if (name.indexOf('.d') == (name.length - 2))
				{
					isDna = true;
				}
			}
		}
		return isDna;
	}

	getSelectedItemsList = function()
	{
		var pfrm = window.opener.document.forms['meludi'];
		
		// Get number of selected extract source items
		var numItems = 0;
		var selItemsList = [];
		for (var i = 0; i < pfrm.extractSourceItems.length; i++)
		{
			if (pfrm.extractSourceItems[i].selected)
			{
				if (pfrm.extractSourceItems[i].item != null)
				{
					selItemsList[numItems] = pfrm.extractSourceItems[i].item;
					numItems++;
				}
			}
		}
		return selItemsList;
	}
	
	return details;
}();

Doc.onLoad(Details.initPage);

