<%@ page
	pageEncoding="UTF-8"
	session="false"
	import="net.sf.basedb.core.Application"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.util.Values"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(request, true);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final String home = ExtensionsControl.getHomeUrl("net.sf.basedb.meludi");
DbControl dc = null;
try
{
	dc = sc.newDbControl();
	final User user = User.getById(dc, sc.getLoggedInUserId());
	final String specimenName = request.getParameter("specimen");
	final int index = Values.getInt(request.getParameter("index"));
	final String mode = request.getParameter("mode");
	final String title = "Edit QIAcube/DNA/RNA details for " + specimenName;
%>
<base:page type="popup" title="<%=title %>">
<base:head 
	scripts="tabcontrol-2.js,~edit_dnarna_prep_details.js,~../meludi-2.js"
	styles="tabcontrol.css"
/>
<base:body>
	<h1><%=title %></h1>

	<div id="page-data"
		data-index="<%=index%>"
		data-mode="<%=mode%>"
	></div>

	<form name="prepdetails">

	<t:tabcontrol id="settings"
		subclass="content dialogtabcontrol" 
		position="bottom" remember="true" 
		>
		<t:tab id="details" title="Details">
			<table class="fullform input100">
			<tr>
				<th>Qiacube position</th>
				<td>
					<input type="text" name="qiacubePosition" id="qiacubePosition"
						style="width: 5em;"	maxlength="3"> Instrument prefix ID ('A'-'Z') + position (1-12), e.g. "B3"
				</td>
			</tr>
			<tr class="dynamic">
				<th></th>
				<td></td>
			</tr>
			</table>
		</t:tab>
	</t:tabcontrol>	
	</form>
	
	<base:buttongroup subclass="dialogbuttons" id="dialogbuttons">
		<base:button id="btnSave" title="Ok" />
		<base:button id="close" title="Cancel" />
	</base:buttongroup>
</base:body>
</base:page>
<%
}
finally
{
	if (dc != null) dc.close();
}
%>