var ExtractionFormCopy = function()
{
	var exreg = {};
	var debug = 0;
	
	exreg.REAGENTS = [
		'xyleneSpecimen', 'etoh995Specimen', 'bufferPkdSpecimen', 'bufferAtlSpecimen',
		'proteinaseKSpecimen', 'rnaseASpecimen', 'allPrepFfpeKit', 'etoh995',
		'bufferRlt', 'bufferFrn', 'bufferRpe', 'bufferAl',
		'bufferAw1', 'bufferAw2', 'bufferAte', 'bufferRdd',
		'rnaseFreeWater', 'dnaseMix', 'rneasyMinEluteSpinColumn', 'qiaampMinEluteSpinColumn'
		];


	var DEFAULT_EXTRACTION_PROTOCOL_NAME_START = 'Extraction_using_Allprep_DNA_RNA_FFPE_kit_with_overnight_proteinaseK_incubation.v';
	var DEFAULT_RNA_VOLUME = 25;
	var DEFAULT_DNA_VOLUME = 25;
	var MINIMAL_PRE_NORMALIZE_QUANTITY = 1.1; // µg
	var EXTRA_QIACUBE_SAMPLE_NAME_START = 'E';
	var protocolMap = {};

	var extraItemsList = [];
	var qiacubeSortedPrefixes = 'CABDEFGHIJKLMNOPQRSTUVWXYZ';
	var qiacubeDateIsAfterIsolationDate = true;
	var qiacubeRunNoIsValid = false;
	var qiacubePositionsAreValid = false;
	var counterBalanceInfoRow = false;
	var createdRna = [];
	
	// Page initialization
	exreg.initPage = function()
	{
		// Step 1
		Events.addEventHandler('step-1', 'wizard-validate', exreg.validateStep1);

		// Step 2
		Events.addEventHandler('step-2', 'wizard-initialize', exreg.initializeStep2);
		Events.addEventHandler('step-2', 'wizard-validate', exreg.validateStep2);
		
		Events.addEventHandler('isolationDate', 'change', Wizard.validateDate);
		Events.addEventHandler('qiacubeDate', 'change', Wizard.validateDate);
		Events.addEventHandler('isolationDate', 'change', exreg.qiacubeDateOnChange);
		Events.addEventHandler('qiacubeDate', 'change', exreg.qiacubeDateOnChange);
		Events.addEventHandler('qiacubeRunNo', 'change', exreg.qiacubeRunNoOnChange);
		
		// Step 3
		Events.addEventHandler('step-3', 'wizard-initialize', exreg.initializeStep3);
		Events.addEventHandler('step-3', 'wizard-validate', exreg.validateStep3);

		Buttons.addClickHandler('downloadSampleIdFile', exreg.downloadSampleIdFile);
		Buttons.addClickHandler('downloadQPcrSampleIdFile', exreg.downloadQPcrSampleIdFile);
		
		// Navigation
		Buttons.addClickHandler('gocancel', Wizard.cancelWizard);
		Buttons.addClickHandler('gonext', Wizard.goNextOnClick);
		Buttons.addClickHandler('gocreate', exreg.createProtocol);
		
		var url = '../Extraction.servlet?ID='+App.getSessionId();
		url += '&cmd=GetStartPlates';		
		url += '&orderDesc=true';		
		Wizard.showLoadingAnimation('Loading unprocessed items...');
		Wizard.asyncJsonRequest(url, exreg.initializeStep1);
	}
	
	exreg.initializeStep1 = function(response)
	{
		var frm = document.forms['meludi'];
		var plates = response.plates;
		
		var startPlateList = frm.startPlate;
		if (plates.length > 0)
		{
			for (var i=0; i < plates.length; i++)
			{
				var plate = plates[i];
				var name = (i+1) + ': ' + Strings.encodeTags(plate.name);
				if (plate.sourceItemNames)
				{
					name += ' -- (';
					name += plate.sourceItemNames.length;
					if (plate.numberExtraQiacubeItems)
					{
						name += ' + ' + plate.numberExtraQiacubeItems;
					}
					name += ')';
				}
				if (plate.extractionDate)
				{
					name += ' -- [' + exreg.asDate(plate.extractionDate) + ']';
				}
				var selected = i == (plates.length - 1);
				var option = new Option(name, plate.id, selected, selected);
				option.plate = plate;
				startPlateList.options[startPlateList.length] = option;
			}
			startPlateList.options[0].selected = true;
		}
		else
		{
			Wizard.setFatalError('No plates available.');
			return;
		}
		Doc.show('step-1');
		Doc.show('gonext');
		Doc.hide('extractSourceItems');
	}

	exreg.validateStep1 = function(event)
	{
		var frm = document.forms['meludi'];
		var startPlate = null;
		for (var i = 0; i < frm.startPlate.length; i++)
		{
			if (frm.startPlate[i].selected)
			{
				startPlate = frm.startPlate[i];
			}
		}
		if (startPlate == null)
		{
			event.preventDefault();
		}
	}
	
	exreg.initializeStep2 = function()
	{
		var frm = document.forms['meludi'];
		var startPlate = null;
		for (var i = 0; i < frm.startPlate.length; i++)
		{
			if (frm.startPlate[i].selected)
			{
				startPlate = frm.startPlate[i];
			}
		}
		if (startPlate == null)
		{
			//alert("exreg.validateStep1(): startPlate == null");
			event.preventDefault();
		}

		frm.startPlate.disabled = true;
/*
		frm.rnaDefaultVolume.value = DEFAULT_RNA_VOLUME;
		frm.dnaDefaultVolume.value = DEFAULT_DNA_VOLUME;
*/

		Wizard.setCurrentStep(2);
		Doc.show('gocancel');
		Doc.show('gonext');
		Doc.hide('startPlateId');
		Doc.hide('extractionProtocolId');
		
		Doc.hide('rnaDefaultVolumeSection');
		Doc.hide('dnaDefaultVolumeSection');
		Doc.hide('xyleneSpecimenSection');
		Doc.hide('etoh995SpecimenSection');
		Doc.hide('bufferPkdSpecimenSection');
		Doc.hide('bufferAtlSpecimenSection');
		Doc.hide('proteinaseKSpecimenSection');
		Doc.hide('rnaseASpecimenSection');

		Doc.hide('etoh995Section');
		Doc.hide('bufferRltSection');
		Doc.hide('bufferFrnSection');
		Doc.hide('bufferRpeSection');
		Doc.hide('bufferAlSection');
		Doc.hide('bufferAw1Section');
		Doc.hide('bufferAw2Section');
		Doc.hide('bufferAteSection');
		Doc.hide('bufferRddSection');
		Doc.hide('rnaseFreeWaterSection');
		Doc.hide('dnaseMixSection');
		Doc.hide('rneasyMinEluteSpinColumnSection');
		Doc.hide('qiaampMinEluteSpinColumnSection');

		frm.isolationDate.focus();
		Events.sendChangeEvent('isolationDate');
		Events.sendChangeEvent('qiacubeDate');

		var url = '../Extraction.servlet?ID='+App.getSessionId();
		url += '&cmd=GetSourceItemListFromStartPlate&startPlateId='+startPlate.value;
		Wizard.asyncJsonRequest(url, exreg.sourceItemListLoaded);
	}

	exreg.sourceItemListLoaded = function(response)
	{
		var frm = document.forms['meludi'];

		var startPlate = response.startplate;
		var specimens = response.specimens;
		var rnas = response.rnas;
		var dnas = response.dnas;
		var items = response.items;
		var startPlateIsProcessed = false;
		extraItemsList = response.extraitems;
		//alert("exreg.sourceItemListLoaded(): specimens.length = " + specimens.length + " rnas.length = " + rnas.length + " dnas.length = " + dnas.length);

		if (startPlate)
		{
			// Extraction parameters
			frm.startPlateName.value = startPlate.name;
			frm.startPlateId.value = startPlate.id;
			// Extraction parameters
			frm.isolationDate.value = startPlate.isolationDate;
			frm.extractionProtocolId.value = startPlate.extractionProtocolId;
			frm.extractionProtocolName.value = startPlate.extractionProtocolName;
			if (startPlate.extractionDate)
			{
				startPlateIsProcessed = true;
			}
			//alert("exreg.sourceItemListLoaded(): startPlate.name = " + startPlate.name + " startPlate.extractionDate = " + startPlate.extractionDate);
			if (startPlateIsProcessed)
			{
				frm.rnaDefaultVolume.value = startPlate.rnaDefaultVolume;
				frm.dnaDefaultVolume.value = startPlate.dnaDefaultVolume;
			}
			// QIAcube parameters
			frm.qiacubeDate.value = startPlate.qiacubeDate;
			frm.qiacubePrimaryPrefix.value = startPlate.qiacubePrimaryPrefix;
			frm.qiacubeSecondaryPrefix.value = startPlate.qiacubeSecondaryPrefix;
			frm.qiacubeRunNo.value = startPlate.qiacubeRunNo;
			frm.qiacubeOperator.value = startPlate.qiacubeOperator;
			frm.allPrepFfpeKit.value = startPlate.allPrepFfpeKit;
			frm.numExtraQiacubeItems.value = startPlate.numExtraQiacubeItems;

			// Disable input fields

			// Extraction parameters
			frm.startPlateName.disabled = true;
			frm.isolationDate.disabled = true;
			frm.extractionProtocolName.disabled = true;
			frm.rnaDefaultVolume.disabled = true;
			frm.dnaDefaultVolume.disabled = true;

			// Specimen reagents
			frm.xyleneSpecimen.disabled = true;
			frm.etoh995Specimen.disabled = true;
			frm.bufferPkdSpecimen.disabled = true;
			frm.bufferAtlSpecimen.disabled = true;
			frm.proteinaseKSpecimen.disabled = true;
			frm.rnaseASpecimen.disabled = true;

			// QIAcube parameters
			frm.qiacubeDate.disabled = true;
			frm.qiacubePrimaryPrefix.disabled = true;
			frm.qiacubeSecondaryPrefix.disabled = true;
			frm.qiacubeRunNo.disabled = true;
			frm.qiacubeOperator.disabled = true;
			frm.allPrepFfpeKit.disabled = true;
			frm.numExtraQiacubeItems.disabled = true;

			// QIAcube reagents
			frm.etoh995.disabled = true;
			frm.bufferRlt.disabled = true;
			frm.bufferFrn.disabled = true;
			frm.bufferRpe.disabled = true;
			frm.bufferAl.disabled = true;
			frm.bufferAw1.disabled = true;
			frm.bufferAw2.disabled = true;
			frm.bufferAte.disabled = true;
			frm.bufferRdd.disabled = true;
			frm.rnaseFreeWater.disabled = true;
			frm.dnaseMix.disabled = true;
			frm.rneasyMinEluteSpinColumn.disabled = true;
			frm.qiaampMinEluteSpinColumn.disabled = true;
		}

		var sourceItemList = frm.extractSourceItems;
		if (items.length > 0)
		{
			var numItems = items.length;
			for (var i=0; i < items.length; i++)
			{
				var item = items[i];
				var name = (i+1) + ': ' + Strings.encodeTags(item.name);
				if (item.bioWell)
				{
					name += ' -- ' + Strings.encodeTags(item.bioWell.bioPlate.name + ' (' + item.bioWell.location+')');
				}
				var selected = true;
				// Identification of item via id works here as specimens and extracts
				// are stored in the same database table using discriminators, and are
				// therefore guaranteed to not have the same id value as another item in the table.
				var option = new Option(name, item.id, selected, selected);
				option.item = item;
				sourceItemList.options[sourceItemList.length] = option;
			}
		}
		else
		{
			Wizard.setFatalError('No items available for processing.');
			return;
		}

		// Load reagents lot no.s from first created DNA for start plate
		if (startPlateIsProcessed)
		{
			// Set form copy default to "report"
			var formCopyTypeMenu = frm.formCopyType;
			var selected = true;
			var option = new Option('Tracking sheet', 'sheet', selected, selected);
			formCopyTypeMenu.options[0] = option;
			option = new Option('Tracking report', 'report', selected, selected);
			option.disabled = false;
			formCopyTypeMenu.options[1] = option;
			frm.formCopyType.value = 'report';
			
			// Find first specimen
			var specimen = null;
			for (var i=0; i < items.length; i++)
			{
				var item = items[i];
				if (exreg.isSpecimen(item))
				{
					specimen = item;
					break;
				}
			}
			
			//alert("exreg.sourceItemListLoaded(): startPlate.name = " + startPlate.name + " specimen.name = " + specimen.name);
			if (specimen)
			{
				var dnaName = specimen.name + '.d';

				var url = '../Extraction.servlet?ID='+App.getSessionId();
				url += '&cmd=GetDna&name='+dnaName;
				Wizard.asyncJsonRequest(url, exreg.reagentLotNosFromDna);
			}
		}
		else
		{
			// Set form copy default to "sheet" and disable option "report"
			var formCopyTypeMenu = frm.formCopyType;
			var selected = true;
			var option = new Option('Tracking sheet', 'sheet', selected, selected);
			formCopyTypeMenu.options[0] = option;
			option = new Option('Tracking report (not available)', 'report', false, false);
			option.disabled = true;
			formCopyTypeMenu.options[1] = option;
		}
	}

	exreg.reagentLotNosFromDna = function(response)
	{
		var frm = document.forms['meludi'];
		var dna = response.dna;

		if (dna)
		{
			// Reset the existing values

			// AllPrep FFPE Kit			
			var allPrepFfpeKit = '';

			// Specimen reagents
			var specXylene = '';
			var specEtoh995 = '';
			var specBufferPkd = '';
			var specBufferAtl = '';
			var specProteinaseK = '';
			var specRNAseA = '';

			// QIAcube reagents
			var bufferRlt = '';
			var etoh995 = '';
			var bufferFrn = '';
			var bufferRpe = '';
			var rnaseFreeWater = '';
			var dnaseMix = '';
			var bufferRdd = '';
			var rneasyMinEluteSpinColumn = '';
			var bufferAl = '';
			var bufferAW1 = '';
			var bufferAW2 = '';
			var bufferAte = '';
			var qiaampMinEluteSpinColumn = '';

			// AllPrep FFPE Kit			
			allPrepFfpeKit = dna.allPrepFfpeKit;

			// Specimen reagents
			specXylene = dna.xyleneSpecimen;
			specEtoh995 = dna.etoh995Specimen;
			specBufferPkd = dna.bufferPkdSpecimen;
			specBufferAtl = dna.bufferAtlSpecimen;
			specProteinaseK = dna.proteinaseKSpecimen;
			specRNAseA = dna.rnaseASpecimen;

			// QIAcube reagents
			bufferRlt = dna.bufferRlt;
			etoh995 = dna.etoh995;
			bufferFrn = dna.bufferFrn;
			bufferRpe = dna.bufferRpe;
			rnaseFreeWater = dna.rnaseFreeWater;
			dnaseMix = dna.dnaseMix;
			bufferRdd = dna.bufferRdd;
			rneasyMinEluteSpinColumn = dna.rneasyMinEluteSpinColumn;
			bufferAl = dna.bufferAl;
			bufferAW1 = dna.bufferAw1;
			bufferAW2 = dna.bufferAw2;
			bufferAte = dna.bufferAte;
			qiaampMinEluteSpinColumn = dna.qiaampMinEluteSpinColum;

			// Update reagent values

			// AllPrep FFPE Kit
			if (frm.allPrepFfpeKit.value == null || frm.allPrepFfpeKit.value == '')
			{
				frm.allPrepFfpeKit.value = allPrepFfpeKit;
			}

			// Specimen reagents
			frm.xyleneSpecimen.value = specXylene;
			frm.etoh995Specimen.value = specEtoh995;
			frm.bufferPkdSpecimen.value = specBufferPkd;
			frm.bufferAtlSpecimen.value = specBufferAtl;
			frm.proteinaseKSpecimen.value = specProteinaseK;
			frm.rnaseASpecimen.value = specRNAseA;

			// QIAcube reagents
			frm.etoh995.value = etoh995;
			frm.bufferRlt.value = bufferRlt;
			frm.bufferFrn.value = bufferFrn;
			frm.bufferRpe.value = bufferRpe;
			frm.bufferAl.value = bufferAl;
			frm.bufferAw1.value = bufferAW1;
			frm.bufferAw2.value = bufferAW2;
			frm.bufferAte.value = bufferAte;
			frm.bufferRdd.value = bufferRdd;
			frm.rnaseFreeWater.value = rnaseFreeWater;
			frm.dnaseMix.value = dnaseMix;
			frm.rneasyMinEluteSpinColumn.value = rneasyMinEluteSpinColumn;
			frm.qiaampMinEluteSpinColumn.value = qiaampMinEluteSpinColumn;

			Doc.show('rnaDefaultVolumeSection');
			Doc.show('dnaDefaultVolumeSection');
			Doc.show('xyleneSpecimenSection');
			Doc.show('etoh995SpecimenSection');
			Doc.show('bufferPkdSpecimenSection');
			Doc.show('bufferAtlSpecimenSection');
			Doc.show('proteinaseKSpecimenSection');
			Doc.show('rnaseASpecimenSection');

			Doc.show('etoh995Section');
			Doc.show('bufferRltSection');
			Doc.show('bufferFrnSection');
			Doc.show('bufferRpeSection');
			Doc.show('bufferAlSection');
			Doc.show('bufferAw1Section');
			Doc.show('bufferAw2Section');
			Doc.show('bufferAteSection');
			Doc.show('bufferRddSection');
			Doc.show('rnaseFreeWaterSection');
			Doc.show('dnaseMixSection');
			Doc.show('rneasyMinEluteSpinColumnSection');
			Doc.show('qiaampMinEluteSpinColumnSection');
		}
	}

	exreg.qiacubeDateOnChange = function()
	{
		var frm = document.forms['meludi'];
		
		var isolationDateIsValid = Wizard.isValid('isolationDate');
		var qiacubeDateIsValid = Wizard.isValid('qiacubeDate');
		
		if (!isolationDateIsValid || !qiacubeDateIsValid) return;

		var isolationDate = Dates.parseString(frm.isolationDate.value, 'yyyyMMdd');
		var qiacubeDate = Dates.parseString(frm.qiacubeDate.value, 'yyyyMMdd');
		if (isolationDate > qiacubeDate)
		{
			Wizard.setInputStatus('qiacubeDate', 'invalid', 'QIAcube date is before isolation date');
			qiacubeDateIsAfterIsolationDate = false;
			return;
		}

		qiacubeDateIsAfterIsolationDate = true;
		
		Wizard.setInputStatus('qiacubeDate', 'valid');
		var url = '../Extraction.servlet?ID='+App.getSessionId();
		url += '&cmd=GetNextQiacubeRunNo&qiacubeDate='+encodeURIComponent(frm.qiacubeDate.value);
		Wizard.showLoadingAnimation('Loading Qiacube run number...');
		Wizard.asyncJsonRequest(url, exreg.gotNextRunNumber);
	}

	exreg.gotNextRunNumber = function(response)
	{
		var frm = document.forms['meludi'];
		frm.qiacubeRunNo.value = response.nextQiacubeRunNo;
		Events.sendChangeEvent('qiacubeRunNo');
	}

	exreg.qiacubeRunNoOnChange = function()
	{
		var frm = document.forms['meludi'];
		var runNumber = frm.qiacubeRunNo.value;
		qiacubeRunNoIsValid = false;

		if (runNumber == '')
		{
			Wizard.setInputStatus('qiacubeRunNo', 'invalid', 'Missing');
			return;
		}
		if (!(parseInt(runNumber, 10) >= 1))
		{
			Wizard.setInputStatus('qiacubeRunNo', 'invalid', 'Must be at least 1');
			return;		
		}
		
		Wizard.setInputStatus('qiacubeRunNo', 'valid');
		qiacubeRunNoIsValid = true;
	}

	exreg.validateStep2 = function(event)
	{
		var valid = true;
		valid &= Wizard.isValid('isolationDate');
		valid &= Wizard.isValid('qiacubeDate');
		valid &= qiacubeRunNoIsValid;
		
		if (!valid) event.preventDefault();
	}

	exreg.initializeStep3 = function()
	{
		var frm = document.forms['meludi'];
		var docType = frm.formCopyType.value;
		var startPlateName = frm.startPlateName.value;
		Doc.element('detailsStartPlateName').innerHTML = '<b>Start plate: ' + startPlateName + '</b>';
		var rnaDefaultVolume = exreg.getNumber(frm.rnaDefaultVolume.value);
		var dnaDefaultVolume = exreg.getNumber(frm.dnaDefaultVolume.value);
		qiacubeSortedPrefixes = exreg.getQiacubeSortedPrefixes();
		
		var html = '<table id="detailsTable" class="step-form">';
		// First header row
		html += '<thead>';
		html += '<tr>';
		html += '<th>Extract</th>';
		html += '<th class="dottedleft">QIAcube</th>';
		html += '<th colspan="1" class="dottedleft"></th>';
/*
		html += '<th colspan="1" class="dottedleft"></th>';
*/
/*
		html += '<th colspan="5" class="dottedleft">RNA</th>';
*/
		if (docType == 'report')
		{
			html += '<th colspan="5" class="dottedleft">RNA</th>';
			html += '<th colspan="5" class="dottedleft">DNA</th>';
		}
		else
		{
			html += '<th colspan="1" class="dottedleft">NanoDrop</th>';
			html += '<th colspan="1" class="dottedleft">RNA</th>';
			html += '<th colspan="1" class="dottedleft">DNA</th>';
		}
		html += '<th class="dottedleft comment">Comment</th>';
		html += '<th></th>';
		html += '</tr>';
		// Second header row
		html += '<tr>';
		html += '<th>source item</th>';
		html += '<th class="dottedleft">position</th>';
		html += '<td class="dottedleft">Storage</td>';
/*
		html += '<td class="dottedleft">Pos</td><td>Vol.</td><td>Conc.</td><td>Quantity</td><td><span id="toggle-normalize-1" class="link" title="Toggle all">Pre-</span></td>';
*/
		if (docType == 'report')
		{
			html += '<td class="dottedleft">NanoDrop</td><td>RNA</td><td>Vol.</td><td>Conc.</td><td>Quantity</td>';
			html += '<td class="dottedleft">DNA</td><td>Vol.</td><td>Conc.</td><td>Quantity</td><td>ΔCt</td>';
		}
		else
		{
			html += '<th class="dottedleft">Plate Pos.</th>';
			html += '<th class="dottedleft">Plate Pos.</th>';
			html += '<th class="dottedleft">Plate Pos.</th>';
		}
		html += '<td class="dottedleft comment"></td>';
		html += '<td></td>';
		html += '</tr>';
		// Third header row
		html += '<tr>';
		html += '<th></th>';
		html += '<th class="dottedleft"></th>';
		html += '<td class="dottedleft">box</td>';
/*
		html += '<td class="dottedleft"></td><td>(µl)</td><td>(ng/µl)</td><td>(µg)</td><td><span id="toggle-normalize-2" class="link" title="Toggle all">normalize</span></td>';
*/
		if (docType == 'report')
		{
			html += '<td class="dottedleft">Pos</td><td>Plate Pos.</td><td>(µl)</td><td>(ng/µl)</td><td>(µg)</td>';
			html += '<td class="dottedleft">Plate Pos.</td><td>(µl)</td><td>(ng/µl)</td><td>(µg)</td><td></td>';
		}
		else
		{
			html += '<td class="dottedleft"></td>';
			html += '<td class="dottedleft"></td>';
			html += '<td class="dottedleft"></td>';
		}
		html += '<td class="dottedleft comment"></td>';
		html += '<td></td>';
		html += '</tr>';
		html += '</thead>';
		html += '<tbody>';

		// Get list of selected extract source items
		var selItemsList = exreg.getSelectedItemsList();
		var numItems = selItemsList.length;
		var numSpecimenItems = exreg.getNumberOfSpecimenItems();
		var numRnaItems = exreg.getNumberOfRnaItems();
		var numDnaItems = exreg.getNumberOfDnaItems();
		var numNanoDropItems = numSpecimenItems + numRnaItems;
		// Get number of extra QIAcube items
		var numExtraQiacubeItems = 0;
		var numExtraQiacubeItemsStr = frm.numExtraQiacubeItems.value;
		if (numExtraQiacubeItemsStr && (numExtraQiacubeItemsStr != ''))
		{
			numExtraQiacubeItems = parseInt(numExtraQiacubeItemsStr, 10);
		}
		var numQiacubeItems = numSpecimenItems + numExtraQiacubeItems;
		var totNumItems = numItems + numExtraQiacubeItems;
		var itemNo = 0;
		var qiacubeItemNo = 0;
		// Set default values for DNA/RNA extraction
		for (var i = 0; i < totNumItems; i++)
		{
			itemNo++;
			var item = null;
			var storageBox = '-';
			var rnaStorageBox = '-';
			var dnaStorageBox = '-';
			if (i < numItems)
			{
				item = selItemsList[i];
				var qiacubePos = null;
				if (exreg.isSpecimen(item))
				{
/*
					alert("exreg.initializeStep3(): item.name = " + item.name + " JSON.stringify(item) = " + JSON.stringify(item));
					if (item.r)
					{
						alert("exreg.initializeStep3(): item.name = " + item.name + " item.r.name = " + item.r.name + " item.r.ndConc = " + item.r.ndConc);
					}
					if (item.d)
					{
						alert("exreg.initializeStep3(): item.name = " + item.name + " item.d.name = " + item.d.name + " item.d.qubitConc = " + item.d.qubitConc + " item.d.deltaCt = " + item.d.deltaCt);
					}
*/
					qiacubeItemNo++;
					qiacubePos = exreg.getDetailedQiaCubePosition(numQiacubeItems, qiacubeItemNo);
				}
/*
				item.originalQuantity = DEFAULT_SPECIMEN_VOLUME;
				item.processedQuantity = DEFAULT_SPECIMEN_USED;
*/
				item.qiacubePosition = qiacubePos;
				item.originalQiacubePosition = qiacubePos;
				//alert("exreg.initializeStep3(): i = " + i + " item.name = " + item.name + " item.qiacubePosition = " + item.qiacubePosition);
				
				var rna = {};
				var dna = {};
				// RNA
				rna.name = item.name + '.r';
				rna.volume = rnaDefaultVolume;
				// DNA
				dna.name = item.name + '.d';
				dna.volume = dnaDefaultVolume;
/*
				item.rna = rna;
				item.dna = dna;
*/
				if (!item.rna)
				{
					item.rna = rna;
				}
				else if (!item.rna.volume)
				{
					item.rna.volume = rnaDefaultVolume;
				}
				if (!item.dna)
				{
					item.dna = dna;
				}
				else if (!item.dna.volume)
				{
					item.dna.volume = dnaDefaultVolume;
				}

				// Input extract source item specimen/RNA/DNA
				if (item.bioWell != null)
				{
					storageBox = Strings.encodeTags(item.bioWell.bioPlate.name + '[' + item.bioWell.location + ']');
				}
				// RNA extract from specimen
				if (item.rna && item.rna.bioWell)
				{
					rnaStorageBox = Strings.encodeTags(item.rna.bioWell.bioPlate.name + '[' + item.rna.bioWell.location + ']');
				}
				// DNA extract from specimen
				if (item.dna && item.dna.bioWell)
				{
					dnaStorageBox = Strings.encodeTags(item.dna.bioWell.bioPlate.name + '[' + item.dna.bioWell.location + ']');
				}
				// Input RNA item storage location should be displayed in the RNA extract storage location column
				if (exreg.isRna(item) && item.bioWell != null)
				{
					rnaStorageBox = Strings.encodeTags(item.bioWell.bioPlate.name + '[' + item.bioWell.location + ']');
				}
				// Input DNA item storage location should be displayed in the DNA extract storage location column
				if (exreg.isDna(item) && item.bioWell != null)
				{
					dnaStorageBox = Strings.encodeTags(item.bioWell.bioPlate.name + '[' + item.bioWell.location + ']');
				}
			}
			else
			{
				// Extra QIAcube item
				item = extraItemsList[i - numItems];
				qiacubeItemNo++;
				var qiacubePos = exreg.getDetailedQiaCubePosition(numQiacubeItems, qiacubeItemNo);
				item.qiacubePosition = qiacubePos;
				item.originalQiacubePosition = qiacubePos;
			}
			html += '<tr class="highlight">';
			html += '<th>' + Strings.encodeTags(item.name) + '</th>';
			html += '<td id="qiacubePosition'+i+'" class="dottedleft"></td>';
			html += '<td class="dottedleft">'+storageBox+'</td>';
			html += '<td id="rnaPos'+i+'" class="dottedleft"></td>';
			html += '<td id="rnaPlatePos'+i+'" class="dottedleft">'+rnaStorageBox+'</td>';
			if (docType == 'report')
			{
				html += '<td id="rnaVol'+i+'"></td>';
				html += '<td id="rnaConc'+i+'" class="bg-filled-50 italic"></td>';
				html += '<td id="rnaQuantity'+i+'" class="bg-filled-50 italic"></td>';
			}
			html += '<td id="dnaPlatePos'+i+'" class="dottedleft">'+dnaStorageBox+'</td>';
			if (docType == 'report')
			{
				html += '<td id="dnaVol'+i+'"></td>';
				html += '<td id="dnaConc'+i+'" class="bg-filled-50 italic"></td>';
/*
				if (exreg.isSpecimen(item) || exreg.isDna(item))
				{
					html += '<td><input type="text" id="dnaConc'+i+'" style="width: 5em;"></intput></td>';
				}
				else
				{
					html += '<td id="dnaConc'+i+'">-</td>';
				}
*/
				html += '<td id="dnaQuantity'+i+'" class="bg-filled-50 italic"></td>';
				html += '<td id="deltaCt'+i+'" class="bg-filled-50 italic"></td>';
			}
			html += '<td id="comments'+i+'" class="dottedleft comment"></td>';
			html += '</tr>';
		}
		if (numQiacubeItems == 1 || numQiacubeItems == 11 || numQiacubeItems == 23)
		{
			// Add extra row for counterbalance in QIAcube
			counterBalanceInfoRow = true;
			var i = numItems;
			var qiacubePos = exreg.getDetailedQiaCubePosition(numQiacubeItems + 1, numQiacubeItems + 1);
				
			html += '<tr class="highlight">';
			html += '<th>' + Strings.encodeTags('COUNTER-BALANCE') + '</th>';
			html += '<td id="qiacubePosition'+i+'" class="dottedleft">'+qiacubePos+'</td>';
			html += '<td class="dottedleft">-</td>';
			html += '<td id="rnaPos'+i+'" class="dottedleft">-</td>';
			html += '<td id="rnaPlatePos'+i+'" class="dottedleft">-</td>';
			if (docType == 'report')
			{
				html += '<td id="rnaVol'+i+'">-</td>';
				html += '<td id="rnaConc'+i+'" class="bg-filled-50 italic">-</td>';
				html += '<td id="rnaQuantity'+i+'" class="bg-filled-50 italic">-</td>';
			}
			html += '<td id="dnaPlatePos'+i+'" class="dottedleft">-</td>';
			if (docType == 'report')
			{		
				html += '<td id="dnaVol'+i+'">-</td>';
				html += '<td id="dnaConc'+i+'" class="bg-filled-50 italic">-</td>';
				html += '<td id="dnaQuantity'+i+'" class="bg-filled-50 italic">-</td>';
				html += '<td id="deltaCt'+i+'" class="bg-filled-50 italic">-</td>';
			}
			html += '<td id="comments'+i+'" class="dottedleft comment">Reminder to use counterbalance</td>';
			html += '</tr>';				
		}
		html += '</tbody>';
		html += '</table>';
		Doc.element('detailsSection').innerHTML = html;
		for (var i = 0; i < numItems; i++)
		{
			Events.addEventHandler('dnaConc'+i, 'change', exreg.dnaConcOnChange);
		}

		Wizard.setCurrentStep(3);

/*		Doc.show('gocancel');
		Doc.show('gocreate');
*/

		Doc.show('sampleIdFilesSection');
		//var includeSpecExtr = true;
		if (docType == 'report')
		{
			Doc.hide('sampleIdFilesSection');
			//includeSpecExtr = true;
		}
		var url = '../Extraction.servlet?ID='+App.getSessionId();
		url += '&cmd=GetSourceItemListFromStartPlate';
		url += '&startPlateId='+startPlate.value;
		//url += '&includeSpecimenExtracts='+includeSpecExtr;
		url += '&includeSpecimenExtracts=true';
		Wizard.asyncJsonRequest(url, exreg.initializeStep3b);
	}
		
	exreg.initializeStep3b = function(response)
	{
		var frm = document.forms['meludi'];
		var rnaDefaultVolume = exreg.getNumber(frm.rnaDefaultVolume.value);
		var dnaDefaultVolume = exreg.getNumber(frm.dnaDefaultVolume.value);

		var docType = frm.formCopyType.value;
		// Set name of form creation button according to document type
		Doc.element('gocreate').innerHTML = '<img src="../images/import.png"></img>Create lab tracking ' + docType;
		Doc.element('gocreate').title = 'Create lab tracking ' + docType;

		var itemNameNanoDropPosJson = exreg.createItemNameNanoDropPosJson();
		//alert("exreg.initializeStep3b(): itemNameNanoDropPosJson = " + JSON.stringify(itemNameNanoDropPosJson));

		// Re-load source item list, as items now have more info attached
		var items = response.items;
		var sourceItemList = frm.extractSourceItems;
		if (items.length > 0)
		{
			var numItems = items.length;
			for (var i=0; i < items.length; i++)
			{
				var item = items[i];
/*
				var name = (i+1) + ': ' + Strings.encodeTags(item.name);
				if (item.bioWell)
				{
					name += ' -- ' + Strings.encodeTags(item.bioWell.bioPlate.name + ' (' + item.bioWell.location +')');
				}
*/
				if (!item.rna)
				{
					var rna = {};
					// RNA
					rna.name = item.name + '.r';
					rna.ndConc = item.ndConc;
					rna.nd260By230 = item.nd260By230;
					rna.nd260By280 = item.nd260By280;
					rna.qubitConc = item.qubitConc;
					rna.deltaCt = item.deltaCt;
					rna.originalQuantity = item.originalQuantity;
					rna.volume = rnaDefaultVolume;				
					rna.well = null;
					item.rna = rna;
				}
				if (!item.dna)
				{
					var dna = {};
					// DNA
					dna.name = item.name + '.d';
					dna.ndConc = item.ndConc;
					dna.nd260By230 = item.nd260By230;
					dna.nd260By280 = item.nd260By280;
					dna.qubitConc = item.qubitConc;
					dna.deltaCt = item.deltaCt;
					dna.originalQuantity = item.originalQuantity;
					dna.volume = dnaDefaultVolume;				
					item.dna = dna;
				}
				// Set RNA well
				item.rna.nanoDropWell = null;
				if (exreg.isSpecimen(item) || exreg.isRna(item))
				{
					var nanoDropPos = itemNameNanoDropPosJson[item.name];
					if (nanoDropPos)
					{
						item.rna.nanoDropWell = nanoDropPos;
					}
				}
				if (docType == 'report')
				{
					if (exreg.isSpecimen(item))
					{
						// Get item QIAcube position from RNA QIAcube instrument prefix and position
						item.qiacubePosition = item.rna.qiacubeInstrumentPrefix + item.rna.qiacubePosition;
					}
					if (exreg.isSpecimen(item) || exreg.isRna(item))
					{
						if (item.rna)
						{
						// Get item RNA volume in µl from weight in ng and concentration in ng/µl
						if (item.rna.ndConc && item.rna.ndConc > 0)
						{
							item.rna.volume = (item.rna.originalQuantity * 1000.0)/item.rna.ndConc;
							item.rna.volume = Math.round(item.rna.volume + 0.0001);
						}
						}
					}
					if (exreg.isSpecimen(item) || exreg.isDna(item))
					{
						if (item.dna)
						{
						// Get item DNA volume in µl from weight in ng and concentration in ng/µl
						if (item.dna.qubitConc && item.dna.qubitConc > 0)
						{
							item.dna.volume = (item.dna.originalQuantity * 1000.0)/item.dna.qubitConc;
							item.dna.volume = Math.round(item.dna.volume + 0.0001);
						}
						}
					}
				}
				else
				{
					if (item.rna)
					{
						item.rna.volume = frm.rnaDefaultVolume.value;
						item.rna.ndConc = null;
						item.rna.originalQuantity = null;
					}

					if (item.dna)
					{
						item.dna.volume = frm.dnaDefaultVolume.value;
						item.dna.qubitConc = null;
						item.dna.originalQuantity = null;
						item.dna.deltaCt = null;
					}
				}
				var selected = true;
				// Identification of item via id works here as specimens and extracts
				// are stored in the same database table using discriminators, and are
				// therefore guaranteed to not have the same id value as another item in the table.
				var option = new Option(name, item.id, selected, selected);
				option.item = item;
				//sourceItemList.options[sourceItemList.length] = option;
				sourceItemList.options[i] = option;
			}
		}
		else
		{
			Wizard.setFatalError('No items available for processing.');
			return;
		}
		
		exreg.updateDetailsTable();
		
		Wizard.setCurrentStep(3);

		Doc.show('gocancel');
		Doc.show('gocreate');
		
		Wizard.keepSessionAlive();
	}

	exreg.createItemNameNanoDropPosJson = function()
	{
		var frm = document.forms['meludi'];

		// Get list of selected extract source items
		var selItemsList = exreg.getSelectedItemsList();
		var numItems = selItemsList.length;
		var numSpecimenItems = exreg.getNumberOfSpecimenItems();
/*
		var numRnaItems = exreg.getNumberOfRnaItems();
		var numDnaItems = exreg.getNumberOfDnaItems();
		var numNanoDropItems = numSpecimenItems + numRnaItems;
*/
		// Get number of extra QIAcube items
		var numExtraQiacubeItems = 0;
		var numExtraQiacubeItemsStr = frm.numExtraQiacubeItems.value;
		if (numExtraQiacubeItemsStr && (numExtraQiacubeItemsStr != ''))
		{
			numExtraQiacubeItems = parseInt(numExtraQiacubeItemsStr, 10);
		}
		var numQiacubeItems = numSpecimenItems + numExtraQiacubeItems;
		var totNumItems = numItems + numExtraQiacubeItems;
/*
		var extraItemsList = exreg.getExtraItemsList(numExtraQiacubeItems);
		// Get sorted list of used integer QIAcube positions for specimens, generalized for more than one QIAcube
		var specSortedIntQiacubePosition = [];
		var qiacubeItemNo = 0;
		for (var i = 0; i < totNumItems; i++)
		{
			if (i < numItems)
			{
				var item = selItemsList[i];
				if (exreg.isSpecimen(item))
				{
					var qiacubePos = exreg.getDetailedQiaCubePosition(numQiacubeItems, qiacubeItemNo + 1);
					var intQiacubePosition = exreg.getIntQiacubePosition(qiacubePosition);
					specSortedIntQiacubePosition[qiacubeItemNo] = intQiacubePosition;
					qiacubeItemNo++;
				}
			}
			else
			{
				// Extra QIAcube item
				var qiacubePos = exreg.getDetailedQiaCubePosition(numQiacubeItems, qiacubeItemNo + 1);
				var intQiacubePosition = exreg.getIntQiacubePosition(qiacubePosition);
				//var item = extraItemsList[i - numItems];
				//var intQiacubePosition = exreg.getIntQiacubePosition(item.qiacubePosition);
				specSortedIntQiacubePosition[qiacubeItemNo] = intQiacubePosition;
				qiacubeItemNo++;
			}
		}
		// Sort for ascending integer values
		specSortedIntQiacubePosition.sort(function(a,b){return a-b});
*/
		var itemNo = 0;
		qiacubeItemNo = 0;
		var nanoDropItemNo = 0;
		var rnaItemNo = 0;
		var intNanoDropPlatePosition = 0;
		// Store NanoDrop positions as JSON object with item names as keys
		var nanoDropJsonStr = '{';
		for (var i = 0; i < totNumItems; i++)
		{
			itemNo++;
			var item = null;
			var qiacubePos = null;
			if (i < numItems)
			{
				item = selItemsList[i];
				if (exreg.isSpecimen(item))
				{
					qiacubeItemNo++;
					intNanoDropPlatePosition = qiacubeItemNo;
					//qiacubePos = exreg.getDetailedQiaCubePosition(numQiacubeItems, qiacubeItemNo);
				}
			}
			else
			{
				// Extra QIAcube item
				qiacubeItemNo++;
				item = extraItemsList[i - numItems];
				//qiacubePos = exreg.getDetailedQiaCubePosition(numQiacubeItems, qiacubeItemNo);
			}
/*
			item.qiacubePosition = qiacubePos;
			var intQiacubePosition = exreg.getIntQiacubePosition(item.qiacubePosition);

			var intNanoDropPlatePosition = intQiacubePosition;
			// Get integer NanoDrop position for specimens from index in sorted list of used integer QIAcube positions
			if (intQiacubePosition)
			{
				var sortIndex = -1;
				for (var j = 0; j < specSortedIntQiacubePosition.length; j++)
				{
					if (intQiacubePosition == specSortedIntQiacubePosition[j])
					{
						sortIndex = j;
					}
				}
				if (sortIndex > -1)
				{
					intNanoDropPlatePosition = sortIndex + 1;
				}
			}
*/
			if (exreg.isRna(item))
			{
				rnaItemNo++;
				intNanoDropPlatePosition = numSpecimenItems + rnaItemNo;
			}
			
			// Calculate NanoDrop well from Qiacube position
			var row;
			var col;
			// Specimens from up to two QIAcube instruments and input RNA items placed on one NanoDrop plate
			if (intNanoDropPlatePosition > 16)
			{
				// (17 - 24) NanoDrop plate for secondary QIAcube, positions A3 - H3
				row = intNanoDropPlatePosition - 17;
				col = 3;
			}
			else if (intNanoDropPlatePosition > 8)
			{
				// ( 9 - 12) NanoDrop plate for primary QIAcube, positions A2 - D2
				// (13 - 16) NanoDrop plate for secondary QIAcube, positions E2 - H2
				row = intNanoDropPlatePosition - 9;
				col = 2;
			}
			else if (intNanoDropPlatePosition > 0)
			{
				// ( 1 -  8) NanoDrop plate for primary QIAcube, positions A1 - H1
				row = intNanoDropPlatePosition - 1;
				col = 1;
			}
			var nanoDropWell = Meludi.wellToAlpha(row) + col;
			// Store NanoDrop position as JSON object with item name as key
			if (nanoDropItemNo > 0)
			{
				nanoDropJsonStr += ',';
			}
			nanoDropJsonStr += '"' + item.name + '":"' + nanoDropWell + '"';
			nanoDropItemNo++;
		}
		nanoDropJsonStr += '}';
		return nanoDropJsonStr;
	}

	exreg.getQiacubeSortedPrefixes = function()
	{
		var frm = document.forms['meludi'];
		var primaryQiacubePrefix = frm.qiacubePrimaryPrefix.value;
		var secondaryQiacubePrefix = frm.qiacubeSecondaryPrefix.value;

		// Get string of current QIAcube prefixes in order
		var fullSortedPrefixSet = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ';
		var sortedPrefixes = '' + primaryQiacubePrefix + secondaryQiacubePrefix;
		for (var i = 0; i < fullSortedPrefixSet.length; i++)
		{
			// Get next prefix
			var prefix = fullSortedPrefixSet.substring(i, i+1);
			// Add prefix to string of sorted prefixes, if not already present
			if (prefix != primaryQiacubePrefix && prefix != secondaryQiacubePrefix)
			{
				sortedPrefixes += prefix;
			}
		}
		return sortedPrefixes;
	}

	exreg.getDetailedQiaCubePosition = function(nitems, i)
	{
		var dpos = null;
		var qiacubePos = null;
		// Two QIAcube instruments are available, denoted 'C' (default) and 'A'
		var qiacubeId = qiacubeSortedPrefixes.substring(0, 1);
		if (nitems == null || nitems < 1 || nitems > 24)
		{
			return null;
		}
		if (i == null || i < 1 || i > nitems)
		{
			return null;
		}
		if (nitems <= 12)
		{
			qiacubePos = exreg.getQiaCubePosition(nitems, i);
		}
		else
		{
			var numItemsQiaCube1 = Math.floor((nitems + 1)/2);
			if (numItemsQiaCube1 == 11)
			{
				numItemsQiaCube1 = 12;
			}
			if (i <= numItemsQiaCube1)
			{
				// Place sample in first QIAcube
				qiacubePos = exreg.getQiaCubePosition(numItemsQiaCube1, i);
			}
			else
			{
				// Place sample in second QIAcube
				var numItemsQiaCube2 = nitems - numItemsQiaCube1;
				qiacubePos = exreg.getQiaCubePosition(numItemsQiaCube2, i - numItemsQiaCube1);
				qiacubeId = qiacubeSortedPrefixes.substring(1, 2);
			}
		}
		if (qiacubeId != null && qiacubePos != null)
		{
			dpos = qiacubeId + qiacubePos;
		}
		return dpos;
	}

	exreg.getQiaCubePosition = function(nitems, i)
	{
		var pos = null;
		if (nitems == null || nitems < 1 || nitems > 12)
		{
			return null;
		}
		if (i == null || i < 1 || i > nitems)
		{
			return null;
		}
		var posArr = ['1','2','3','4','5','6','7','8','9','10','11','12'];
		if (nitems == 2)
		{
			posArr = ['1','7','','','','','','','','','',''];
		}
		else if (nitems == 3)
		{
			posArr = ['1','5','9','','','','','','','','',''];
		}
		else if (nitems == 4)
		{
			posArr = ['1','2','7','8','','','','','','','',''];
		}
		else if (nitems == 5)
		{
			posArr = ['1','2','5','8','9','','','','','','',''];
		}
		else if (nitems == 6)
		{
			posArr = ['1','2','3','7','8','9','','','','','',''];
		}
		else if (nitems == 7)
		{
			posArr = ['1','2','3','6','7','9','10','','','','',''];
		}
		else if (nitems == 8)
		{
			posArr = ['1','2','3','4','7','8','9','10','','','',''];
		}
		else if (nitems == 9)
		{
			posArr = ['1','2','3','5','6','7','9','10','11','','',''];
		}
		else if (nitems == 10)
		{
			posArr = ['1','2','3','4','5','7','8','9','10','11','',''];
		}
		else if (nitems == 11)
		{
			// Counterbalance blank vial filled with water needed i position 12.
			posArr = ['1','2','3','4','5','6','7','8','9','10','11',''];
		}
		pos = posArr[i-1];
		return pos;
	}

	exreg.toggleNormalize = function()
	{
		var frm = document.forms['meludi'];
		// Get list of selected extract source items
		var selItemsList = exreg.getSelectedItemsList();
		var numItems = selItemsList.length;
		// Toggle normalize check box status
		var check = null;
		for (var i = 0; i < numItems; i++)
		{
			var item = selItemsList[i];
			if (exreg.isSpecimen(item) || exreg.isRna(item))
			{
				if (!frm['rnaPreNormalize'+i].disabled)
				{
					if (check == null) check = !frm['rnaPreNormalize'+i].checked;
					frm['rnaPreNormalize'+i].checked = check;
				}
			}
		}
	}
	
	exreg.getSelectedItemsList = function()
	{
		var frm = document.forms['meludi'];

		// Get number of selected extract source items
		var numItems = 0;
		var selItemsList = [];
		for (var i = 0; i < frm.extractSourceItems.length; i++)
		{
			if (frm.extractSourceItems[i].selected)
			{
				if (frm.extractSourceItems[i].item != null)
				{
					selItemsList[numItems] = frm.extractSourceItems[i].item;
					numItems++;
				}
			}
		}
		return selItemsList;
	}

	exreg.getExtraItemsList = function(numExtraItems)
	{
		// Create extra items
		for (var i = 0; i < numExtraItems; i++)
		{
			var no = i + 1;
			var numStr = '' + no;
			if (no < 10)
			{
				numStr = '0' + numStr;
			}
			var jsonString = '{"name":"' + EXTRA_QIACUBE_SAMPLE_NAME_START + numStr + '","qiacubePosition":"","originalQiacubePosition":""}';
			var extraItem = JSON.parse(jsonString);
			extraItemsList[i] = extraItem;
		}
		return extraItemsList;
	}

	exreg.isSpecimen = function(item)
	{
		var isSpecimen = false;
		if (item != null)
		{
			if (!exreg.isRna(item) && !exreg.isDna(item))
			{
				var name = item.name;
				if (name != null)
				{
					// Check if item name does not start with string EXTRA_QIACUBE_SAMPLE_NAME_START
					if (name.indexOf(EXTRA_QIACUBE_SAMPLE_NAME_START) != 0)
					{
						isSpecimen = true;
					}
				}
			}
		}
		return isSpecimen;
	}

	exreg.isRna = function(item)
	{
		var isRna = false;
		if (item != null)
		{
			var name = item.name;
			if (name != null)
			{
				// Check if item name ends with ".r"
				if (name.indexOf('.r') == (name.length - 2))
				{
					isRna = true;
				}
			}
		}
		return isRna;
	}

	exreg.isDna = function(item)
	{
		var isDna = false;
		if (item != null)
		{
			var name = item.name;
			if (name != null)
			{
				// Check if item name ends with ".d"
				if (name.indexOf('.d') == (name.length - 2))
				{
					isDna = true;
				}
			}
		}
		return isDna;
	}

	exreg.getNumberOfSpecimenItems = function()
	{
		// Get list of selected extract source items
		var selItemsList = exreg.getSelectedItemsList();
		var numItems = selItemsList.length;
		var numSpecimen = 0;
		for (var i = 0; i < numItems; i++)
		{
			var item = selItemsList[i];
			if (exreg.isSpecimen(item))
			{
				numSpecimen++;
			}
		}
		return numSpecimen;
	}
	
	exreg.getNumberOfRnaItems = function()
	{
		// Get list of selected extract source items
		var selItemsList = exreg.getSelectedItemsList();
		var numItems = selItemsList.length;
		var numRna = 0;
		for (var i = 0; i < numItems; i++)
		{
			var item = selItemsList[i];
			if (exreg.isRna(item))
			{
				numRna++;
			}
		}
		return numRna;
	}
	
	exreg.getNumberOfDnaItems = function()
	{
		// Get list of selected extract source items
		var selItemsList = exreg.getSelectedItemsList();
		var numItems = selItemsList.length;
		var numDna = 0;
		for (var i = 0; i < numItems; i++)
		{
			var item = selItemsList[i];
			if (exreg.isDna(item))
			{
				numDna++;
			}
		}
		return numDna;
	}
	
	exreg.dnaConcOnChange = function(event)
	{
		var frm = document.forms['meludi'];
		// Get list of selected extract source items
		var selItemsList = exreg.getSelectedItemsList();
		var numItems = selItemsList.length;
		// Update DNA concentration values
		for (var i = 0; i < numItems; i++)
		{
			var item = selItemsList[i];
			var dnaConc = Doc.element('dnaConc'+i);
			if (dnaConc != null)
			{
				if (dnaConc.value != null && dnaConc.value != '' && dnaConc.value != '-')
				{
					item.dna.qubitConc = exreg.getNumber(dnaConc.value);
				}
/*
				else
				{
					item.dna.qubitConc = null;
				}
*/
			}
		}
		exreg.updateDetailsTable();
	}

	exreg.updateDetailsTable = function()
	{
		var frm = document.forms['meludi'];
		var docType = frm.formCopyType.value;
		var rnaDefaultVolume = exreg.getNumber(frm.rnaDefaultVolume.value);
		var dnaDefaultVolume = exreg.getNumber(frm.dnaDefaultVolume.value);
		var hasQiacubePosition = [];
		var duplicatePosition = 0;

		// Get list of selected extract source items
		var selItemsList = exreg.getSelectedItemsList();
		var numItems = selItemsList.length;
		var numSpecimenItems = exreg.getNumberOfSpecimenItems();
		var numRnaItems = exreg.getNumberOfRnaItems();
		var numDnaItems = exreg.getNumberOfDnaItems();
		var numNanoDropItems = numSpecimenItems + numRnaItems;
		// Get number of extra QIAcube items
		var numExtraQiacubeItems = 0;
		var numExtraQiacubeItemsStr = frm.numExtraQiacubeItems.value;
		if (numExtraQiacubeItemsStr && (numExtraQiacubeItemsStr != ''))
		{
			numExtraQiacubeItems = parseInt(numExtraQiacubeItemsStr, 10);
		}
		var numQiacubeItems = numSpecimenItems + numExtraQiacubeItems;
		var totNumItems = numItems + numExtraQiacubeItems;
		// Get sorted list of used integer QIAcube positions for specimens, generalized for more than one QIAcube
		var specSortedIntQiacubePosition = [];
		var qiacubeItemNo = 0;
		for (var i = 0; i < totNumItems; i++)
		{
			if (i < numItems)
			{
				var item = selItemsList[i];
				if (exreg.isSpecimen(item))
				{
					var qiacubePos = exreg.getDetailedQiaCubePosition(numQiacubeItems, qiacubeItemNo + 1);
					if (docType == 'sheet')
					{
						item.qiacubePosition = qiacubePos;
					}
					var intQiacubePosition = exreg.getIntQiacubePosition(item.qiacubePosition);
					specSortedIntQiacubePosition[qiacubeItemNo] = intQiacubePosition;
					qiacubeItemNo++;
				}
			}
			else
			{
				// Extra QIAcube item
				var item = extraItemsList[i - numItems];
				var intQiacubePosition = exreg.getIntQiacubePosition(item.qiacubePosition);
				specSortedIntQiacubePosition[qiacubeItemNo] = intQiacubePosition;
				qiacubeItemNo++;
			}
		}
		// Sort for ascending integer values
		specSortedIntQiacubePosition.sort(function(a,b){return a-b});
/*
		var numSpecimenItems = exreg.getNumberOfSpecimenItems();
		var numRnaItems = exreg.getNumberOfRnaItems();
		var numDnaItems = exreg.getNumberOfDnaItems();
		var numNanoDropItems = numSpecimenItems + numRnaItems;
		// Get number of extra QIAcube items
		var numExtraQiacubeItems = 0;
		var numExtraQiacubeItemsStr = frm.numExtraQiacubeItems.value;
		if (numExtraQiacubeItemsStr && (numExtraQiacubeItemsStr != ''))
		{
			numExtraQiacubeItems = parseInt(numExtraQiacubeItemsStr, 10);
		}
		var numQiacubeItems = numSpecimenItems + numExtraQiacubeItems;
*/
		var rnaItemNo = 0;
		var qiacubeItemNo = 0;
		// Set default values for DNA/RNA extraction
		for (var i = 0; i < totNumItems; i++)
		{
			var rnaStorageBox = '-';
			var dnaStorageBox = '-';
			var item = null;
			if (i < numItems)
			{
				item = selItemsList[i];
				var qiacubePos = null;
				if (exreg.isSpecimen(item))
				{
					qiacubeItemNo++;
					qiacubePos = exreg.getDetailedQiaCubePosition(numQiacubeItems, qiacubeItemNo);
					if (docType == 'sheet')
					{
						item.qiacubePosition = qiacubePos;
					}
				}
				item.originalQiacubePosition = qiacubePos;

				// RNA extract from specimen
				if (item.rna && item.rna.bioWell)
				{
					rnaStorageBox = Strings.encodeTags(item.rna.bioWell.bioPlate.name + '[' + item.rna.bioWell.location + ']');
				}
				// DNA extract from specimen
				if (item.dna && item.dna.bioWell)
				{
					dnaStorageBox = Strings.encodeTags(item.dna.bioWell.bioPlate.name + '[' + item.dna.bioWell.location + ']');
				}
				// Input RNA item storage location should be displayed in the RNA extract storage location column
				if (exreg.isRna(item) && item.bioWell != null)
				{
					rnaStorageBox = Strings.encodeTags(item.bioWell.bioPlate.name + '[' + item.bioWell.location + ']');
				}
				// Input DNA item storage location should be displayed in the DNA extract storage location column
				if (exreg.isDna(item) && item.bioWell != null)
				{
					dnaStorageBox = Strings.encodeTags(item.bioWell.bioPlate.name + '[' + item.bioWell.location + ']');
				}
			}
			else
			{
				// Extra QIAcube item
				item = extraItemsList[i - numItems];
			}
			if (Doc.element('qiacubePosition'+i))
			{
				Doc.element('qiacubePosition'+i).innerHTML = item.qiacubePosition;
				Doc.addOrRemoveClass('qiacubePosition'+i, 'nondefault', item.qiacubePosition != item.originalQiacubePosition);
			}

			var intQiacubePosition = exreg.getIntQiacubePosition(item.qiacubePosition);			
			if (intQiacubePosition != null)
			{
				if (hasQiacubePosition[intQiacubePosition])
				{
					duplicatePosition = intQiacubePosition;
				}
				else
				{
					hasQiacubePosition[intQiacubePosition] = true;
				}
			}
			var intNanoDropPlatePosition = intQiacubePosition;
			// Get integer NanoDrop position for specimens from index in sorted list of used integer QIAcube positions
			if (intQiacubePosition)
			{
				var sortIndex = -1;
				for (var j = 0; j < specSortedIntQiacubePosition.length; j++)
				{
					if (intQiacubePosition == specSortedIntQiacubePosition[j])
					{
						sortIndex = j;
					}
				}
				if (sortIndex > -1)
				{
					intNanoDropPlatePosition = sortIndex + 1;
				}
			}
			if (exreg.isRna(item))
			{
				rnaItemNo++;
				intNanoDropPlatePosition = numSpecimenItems + rnaItemNo;
			}
			
			// Calculate NanoDrop well from Qiacube position
			var row;
			var col;
			// Specimens from up to two QIAcube instruments and input RNA items placed on one NanoDrop plate
			if (intNanoDropPlatePosition > 16)
			{
				// (17 - 24) NanoDrop plate for secondary QIAcube, positions A3 - H3
				row = intNanoDropPlatePosition - 17;
				col = 3;
			}
			else if (intNanoDropPlatePosition > 8)
			{
				// ( 9 - 12) NanoDrop plate for primary QIAcube, positions A2 - D2
				// (13 - 16) NanoDrop plate for secondary QIAcube, positions E2 - H2
				row = intNanoDropPlatePosition - 9;
				col = 2;
			}
			else if (intNanoDropPlatePosition > 0)
			{
				// ( 1 -  8) NanoDrop plate for primary QIAcube, positions A1 - H1
				row = intNanoDropPlatePosition - 1;
				col = 1;
			}
			var nanoDropWell = Meludi.wellToAlpha(row) + col;
			if (i < numItems)
			{
			
				if (exreg.isSpecimen(item) || exreg.isRna(item))
				{
					item.rna.nanoDropWell = nanoDropWell;
/*
					if (item.rna)
					{
						item.rna.well = nanoDropWell;
					}
*/
				}
				else
				{
					if (item.dna)
					{
						//item.dna.well = null;
						item.rna.nanoDropWell = null;
					}					
				}

				if (Doc.element('rnaPlatePos'+i))
				{
					Doc.element('rnaPlatePos'+i).innerHTML = rnaStorageBox;
				}
				if (Doc.element('dnaPlatePos'+i))
				{
					Doc.element('dnaPlatePos'+i).innerHTML = dnaStorageBox;
				}
				if (item.dna)
				{
					if (Doc.element('dnaVol'+i))
					{
						Doc.element('dnaVol'+i).innerHTML = item.dna.volume;
						Doc.addOrRemoveClass('dnaVol'+i, 'nondefault', item.dna.volume != dnaDefaultVolume);
					}
					if (Doc.element('dnaConc'+i))
					{
						var dnaConc = Doc.element('dnaConc'+i);
						dnaConc.innerHTML = Meludi.formatNumber(item.dna.qubitConc) || '-';
						dnaConc.title = '260/280=' + item.dna.nd260by280 + '\n260/230=' + item.dna.nd260by230;
						if (dnaConc != null)
						{
							var dnaConcValue = dnaConc.value;
							if (dnaConcValue != null && dnaConcValue != '-' && dnaConcValue != '')
							{
								item.dna.qubitConc = exreg.getNumber(dnaConcValue);
							}
						}
					}
					item.dna.quantity = item.dna.qubitConc * item.dna.volume / 1000;
					if (Doc.element('dnaQuantity'+i))
					{
						Doc.element('dnaQuantity'+i).innerHTML = Meludi.formatNumber(item.dna.quantity || null, null, 2) || '-';
					}

					var deltaCt = Doc.element('deltaCt'+i);
					if (deltaCt)
					{
						var deltaCtValue = deltaCt.value;
						if (deltaCtValue != null && deltaCtValue != '-' && deltaCtValue != '')
						{
							item.dna.deltaCt = exreg.getNumber(deltaCtValue);
						}
						deltaCt.innerHTML = Meludi.formatNumber(item.dna.deltaCt) || '-';
					}
				}
				else
				{
					if (Doc.element('dnaVol'+i))
					{
						Doc.element('dnaVol'+i).innerHTML =  dnaDefaultVolume;
					}
					if (Doc.element('dnaConc'+i))
					{
						var dnaConc = Doc.element('dnaConc'+i);
						dnaConc.innerHTML = '-';
						dnaConc.title = '260/280=' + null + '\n260/230=' + null;
					}
					if (Doc.element('dnaQuantity'+i))
					{
						Doc.element('dnaQuantity'+i).innerHTML = '-';
					}

					var deltaCt = Doc.element('deltaCt'+i);
					if (deltaCt)
					{
						deltaCt.innerHTML = '-';
					}
				}

				if (item.rna)
				{
					if (Doc.element('rnaPos'+i))
					{
						Doc.element('rnaPos'+i).innerHTML = item.rna.nanoDropWell;
						Doc.addOrRemoveClass('rnaPos'+i, 'nondefault', item.qiacubePosition != item.originalQiacubePosition);
					}
					if (Doc.element('rnaVol'+i))
					{
						Doc.element('rnaVol'+i).innerHTML = item.rna.volume;
						Doc.addOrRemoveClass('rnaVol'+i, 'nondefault', item.rna.volume != rnaDefaultVolume);
					}
					if (Doc.element('rnaConc'+i))
					{
						var rnaConc = Doc.element('rnaConc'+i);
						rnaConc.innerHTML = Meludi.formatNumber(item.rna.ndConc) || '-';
						rnaConc.title = '260/280=' + item.rna.nd260by280 + '\n260/230=' + item.rna.nd260by230;
					}
				
					item.rna.quantity = item.rna.ndConc * item.rna.volume / 1000;
					var enoughQuantity = item.rna.quantity >= MINIMAL_PRE_NORMALIZE_QUANTITY;
					item.rna.flag = enoughQuantity ? null : 'NotEnoughRemainingQuantity';
				
					if (exreg.isSpecimen(item) || exreg.isRna(item))
					{
						if (Doc.element('rnaQuantity'+i))
						{
							Doc.element('rnaQuantity'+i).innerHTML = Meludi.formatNumber(item.rna.quantity || null, null, 2) || '-';
						}
					}
				}
				else
				{
					if (Doc.element('rnaPos'+i))
					{
						if (exreg.isRna(item))
						{
							Doc.element('rnaPos'+i).innerHTML = nanoDropWell;
						}						
						if (exreg.isDna(item))
						{
							Doc.element('rnaPos'+i).innerHTML = null;
						}						
					}
					if (Doc.element('rnaVol'+i))
					{
						Doc.element('rnaVol'+i).innerHTML = rnaDefaultVolume;
					}
					if (Doc.element('rnaConc'+i))
					{
						var rnaConc = Doc.element('rnaConc'+i);
						rnaConc.innerHTML = '-';
						rnaConc.title = '260/280=' + null + '\n260/230=' + null;
					}
				
					if (exreg.isSpecimen(item) || exreg.isRna(item))
					{
						if (Doc.element('rnaQuantity'+i))
						{
							Doc.element('rnaQuantity'+i).innerHTML = '-';
						}
					}
				}

				var cmnt = Doc.element('comments'+i);
				var tooltip = [];
				var comment = [];
/*
				if (item.comment || item.dna.comment || item.rna.comment)
*/
				if (item.operatorDeliveryComment || item.comment)
				{
					// Display operator delivery comments directly in the comment field
					if (item.operatorDeliveryComment)
					{
						comment[0] = item.operatorDeliveryComment;
						tooltip[tooltip.length] = 'Op.Del.Cmt: ' + item.operatorDeliveryComment;
					}
					else
					{
						comment[0] = 'Yes';
					}
					if (item.comment) tooltip[tooltip.length] = 'Specimen: ' + item.comment;
				}
				if (item.rna)
				{
					if (item.rna.comment)
					{
						comment[0] = 'Yes';
						if (item.rna.comment) tooltip[tooltip.length] = 'RNA: ' + item.rna.comment;
					}
				}
				if (item.dna)
				{
					if (item.dna.comment)
					{
						comment[0] = 'Yes';
						if (item.dna.comment) tooltip[tooltip.length] = 'DNA: ' + item.dna.comment;
					}
				}
				
				var modifiedReagents = false;
				for (var rgNo = 0; rgNo < exreg.REAGENTS.length; rgNo++)
				{
					var rg = exreg.REAGENTS[rgNo];
					if (item[rg]) 
					{
						tooltip[tooltip.length] = Doc.element(rg+'.title').innerHTML + ': ' + Strings.encodeTags(item[rg]);
						modifiedReagents = true;
					}
				}
				if (modifiedReagents)
				{
					comment[comment.length] = 'Reagents';
				}

				if (cmnt)
				{				
					if (tooltip.length > 0)
					{
						cmnt.innerHTML = comment.join(', ');
						Doc.addClass(cmnt, 'nondefault');
						cmnt.title = tooltip.join('\n');
					}
					else
					{
						cmnt.innerHTML = '';
						Doc.removeClass(cmnt, 'nondefault');
						cmnt.title = null;
					}
				}
			}
		}
		
		if (duplicatePosition)
		{
			var duplicatePositionStr = exreg.getQiacubePosition(duplicatePosition);
			qiacubePositionsAreValid = false;
		}
		else
		{
			qiacubePositionsAreValid = true;
		}
	}

	/**
		Returns a pure integer position value from a QIAcube position
		string with optional instrument letter prefix A-Z.
		Returns `null` if input position string is `null`.

		positionStr = integer          => QIAcube position = integer (1-12)
		positionStr = Prefix + integer => QIAcube position = integer + 12*<Prefix order number 0-25>
	 */
	exreg.getIntQiacubePosition = function(positionStr)
	{
		var intPos = null;
		if (positionStr)
		{
			// Check if string contains uppercase letter + QIAcube position number 1-12
			if (/^[A-Z]([2-9]|1[0-2]?)$/.test(positionStr))
			{
				var qiaCubePrefix = positionStr.substring(0,1);
				// Get QIAcube prefix order number 0-25
				var qiacubePrefixOrder = qiacubeSortedPrefixes.indexOf(qiaCubePrefix);
				if (qiacubePrefixOrder >= 0)
				{
					intPos = parseInt(positionStr.substring(1)) + 12*qiacubePrefixOrder;
				}
			}
			if (intPos == null)
			{
				intPos = parseInt(positionStr);
			}
		}
		return intPos;
	}

	/**
		Returns a QIAcube position string with optional instrument
		letter prefix A-Z from a pure integer position value.

		Examples for qiacubeSortedPrefixes = 'CABDEFGHIJKLMNOPQRSTUVWXYZ' ("C" is default)
		intPosition (  1 -  12) => positionStr = 'C' + integer
		intPosition ( 13 -  24) => positionStr = 'A' + (integer - 12)
		intPosition (301 - 312) => positionStr = 'Z' + (integer - 300)
	 */
	exreg.getQiacubePosition = function(intPosition)
	{
		var qiacubePositionStr = null;
		if (intPosition && intPosition > 0)
		{
			var numPrefixes = qiacubeSortedPrefixes.length;
			var prefixIndex = Math.floor(intPosition/12);
			if (prefixIndex < numPrefixes)
			{
				var qiacubePrefix = qiacubeSortedPrefixes.substring(prefixIndex, prefixIndex + 1);
				var qiacubePos = intPosition - 12*prefixIndex;
				qiacubePositionStr = qiacubePrefix + qiacubePos;
			}
			else
			{
				qiacubePositionStr = '' + intPosition;
			}
		}
		return qiacubePositionStr;
	}

	exreg.getNumber = function(sValue)
	{
		return parseFloat(sValue.replace(/,/, '.'));
	}

	exreg.findRnaOrDnaNanoDrop = function(sampleId, lineNo, messageId)
	{
		// Get list of selected extract source items
		var selItemsList = exreg.getSelectedItemsList();
		var numItems = selItemsList.length;
		for (var i = 0; i < numItems; i++)
		{
			var item = selItemsList[i];
			var test_rna_name = item.rna.name;
			var test_dna_name = item.dna.name;
			if (exreg.isRna(item))
			{
				test_rna_name = item.name;
				test_dna_name = item.name;
			}
			if (test_rna_name == sampleId)
			{
				return item.rna;
			}
			else if (test_dna_name == sampleId)
			{
				return item.dna;
			}
		}
		Wizard.setInputStatus(messageId, 'invalid', 'On line ' + lineNo + '; Can\'t find RNA/DNA with name "' + sampleId + '"');
		return null;
	}

	exreg.findRnaOrDna = function(sampleId, lineNo, messageId)
	{
		// Get list of selected extract source items
		var selItemsList = exreg.getSelectedItemsList();
		var numItems = selItemsList.length;
		for (var i = 0; i < numItems; i++)
		{
			var item = selItemsList[i];
			if (item.rna.name == sampleId)
			{
				return item.rna;
			}
			else if (item.dna.name == sampleId)
			{
				return item.dna;
			}
		}
		Wizard.setInputStatus(messageId, 'invalid', 'On line ' + lineNo + '; Can\'t find RNA/DNA with name "' + sampleId + '"');
		return null;
	}

	exreg.downloadSampleIdFile = function()
	{
		var frm = document.forms['meludi'];

		if (!qiacubePositionsAreValid)
		{
			Forms.showNotification('downloadSampleIdFile', 'QIAcube positions are not valid. Please fix before downloading the file.');
			return;
		}

		var itemNames = [];
		var url = '../Extraction.servlet?ID='+App.getSessionId();
		url += '&cmd=DownloadNanoDropSampleIdFile';
		url += '&startPlateName='+encodeURIComponent(frm.startPlateName.value);
		url += '&qiacubeDate='+encodeURIComponent(frm.qiacubeDate.value);
		url += '&qiacubeRunNo='+encodeURIComponent(frm.qiacubeRunNo.value);
		url += '&blankControlColumn='+encodeURIComponent(frm.blankControlColumn.checked);
		
		// Get list of selected extract source items
		var selItemsList = exreg.getSelectedItemsList();
		var numItems = selItemsList.length;
		var itemNo = 0;
		for (var i = 0; i < numItems; i++)
		{
			var item = selItemsList[i];
			if (exreg.isSpecimen(item) || exreg.isRna(item))
			{
				itemNames[itemNo] = item.name;
				itemNo++;
			}
		}
		url += '&itemNames=' + encodeURIComponent(itemNames.join(','));
		window.open(url);
	}

	exreg.downloadQPcrSampleIdFile = function()
	{
		var frm = document.forms['meludi'];
		var itemNames = [];
		var url = '../Extraction.servlet?ID='+App.getSessionId();
		url += '&cmd=DownloadQPcrSampleIdFile';
		url += '&startPlateName='+encodeURIComponent(frm.startPlateName.value);
		url += '&qiacubeDate='+encodeURIComponent(frm.qiacubeDate.value);
		url += '&qiacubeRunNo='+encodeURIComponent(frm.qiacubeRunNo.value);

		// Get list of selected extract source items
		var selItemsList = exreg.getSelectedItemsList();
		var numItems = selItemsList.length;
		var itemNo = 0;
		for (var i = 0; i < numItems; i++)
		{
			var item = selItemsList[i];
			if (exreg.isSpecimen(item) || exreg.isDna(item))
			{
				itemNames[itemNo] = item.name;
				itemNo++;
			}
		}
		url += '&itemNames=' + encodeURIComponent(itemNames.join(','));
		window.open(url);
	}

	exreg.validateStep3 = function(event)
	{
		var valid = true;
		valid &= nanoDropFileIsValid;
		valid &= qiacubePositionsAreValid;
		
		if (!valid) event.preventDefault();
	}

	exreg.createProtocol = function()
	{
		var frm = document.forms['meludi'];
		var submitInfo = {};
		submitInfo.items = [];

		submitInfo.docMode = frm.formCopyType.value;
		// Get list of selected extract source items
		var selItemsList = exreg.getSelectedItemsList();
		var numItems = selItemsList.length;
		// Get number of extra QIAcube items
		var numExtraQiacubeItems = 0;
		var numExtraQiacubeItemsStr = frm.numExtraQiacubeItems.value;
		if (numExtraQiacubeItemsStr && (numExtraQiacubeItemsStr != ''))
		{
			numExtraQiacubeItems = parseInt(numExtraQiacubeItemsStr, 10);
		}
		submitInfo.numExtraQiacubeItems = numExtraQiacubeItems;
		var totNumItems = numItems + numExtraQiacubeItems;
		for (var i = 0; i < totNumItems; i++)
		{
			var item = null;
			if (i < numItems)
			{
				item = selItemsList[i];
			}
			else
			{
				// Extra QIAcube item
				item = extraItemsList[i - numItems];
			}
			submitInfo.items[submitInfo.items.length] = item;
		}

		// Extraction
		submitInfo.startPlateName = frm.startPlateName.value;
		submitInfo.numExtraQiacubeItems = frm.numExtraQiacubeItems.value;
		submitInfo.isolationDate = frm.isolationDate.value;
		submitInfo.extractionProtocol = parseInt(frm.extractionProtocolId.value, 10);
		var extractionProtocolName = frm.extractionProtocolName.value;
		var protocolVersionNo = '';
		if (extractionProtocolName)
		{
			protocolVersionNo = extractionProtocolName;
			// Remove part of string up to and including last "v"
			var vIndex = protocolVersionNo.indexOf('v');
			while (vIndex >= 0)
			{
				// Remove part of string up to and including first "v"
				protocolVersionNo = protocolVersionNo.substring(vIndex + 1);
				vIndex = protocolVersionNo.indexOf('v');
			}
		}
		var protocolPreviewFlag = null;
		submitInfo.extractionProtocolName = extractionProtocolName;
		submitInfo.protocolVersionNo = protocolVersionNo;
		submitInfo.protocolPreviewFlag = protocolPreviewFlag;
		submitInfo.dnaDefaultVolume = exreg.getNumber(frm.dnaDefaultVolume.value);
		if (submitInfo.docMode != 'report')
		{
			submitInfo.dnaDefaultVolume = null;
		}
		// QIAcube
		submitInfo.qiacubeDate = frm.qiacubeDate.value;
		submitInfo.qiacubeRunNo = parseInt(frm.qiacubeRunNo.value, 10);
		submitInfo.qiacubeOperator = frm.qiacubeOperator.value;
		submitInfo.allPrepFfpeKit = frm.allPrepFfpeKit.value;

		// Save values in hidden input fields for retrieval after HTML request
		var submitInfoJsonStr = JSON.stringify(submitInfo);
		frm.hiddenSubmitInfo.value = submitInfoJsonStr;
		frm.hiddenNumItems.value = submitInfo.items.length;
		frm.hiddenCounterBalanceInfoRow.value = counterBalanceInfoRow;

		// Calling frm.submit() will change jsp file to extraction_protocol2.jsp
		frm.submit();
	}
	
	// Format value as a date in format yyyy-mm-dd
	exreg.asDate = function(value)
	{
		if (!value) return '';
		if (value.length == 8)
		{
			value = value.substr(0, 4) + '-' + value.substr(4, 2) + '-' + value.substr(6, 2);
		}
		return value;
	}

	return exreg;
}();

Doc.onLoad(ExtractionFormCopy.initPage);

